# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from .. import _utilities, _tables

__all__ = ['IndustrialPidProject']


class IndustrialPidProject(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 pid_organisation_id: Optional[pulumi.Input[str]] = None,
                 pid_project_desc: Optional[pulumi.Input[str]] = None,
                 pid_project_name: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Provides a Brain Industrial Pid Project resource.

        > **NOTE:** Available in v1.113.0+.

        ## Example Usage

        Basic Usage

        ```python
        import pulumi
        import pulumi_alicloud as alicloud

        example = alicloud.brain.IndustrialPidProject("example",
            pid_organisation_id="3e74e684-cbb5-xxxx",
            pid_project_name="tf-testAcc")
        ```

        ## Import

        Brain Industrial Pid Project can be imported using the id, e.g.

        ```sh
         $ pulumi import alicloud:brain/industrialPidProject:IndustrialPidProject example <id>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] pid_organisation_id: The ID of Pid Organisation.
        :param pulumi.Input[str] pid_project_desc: The description of Pid Project.
        :param pulumi.Input[str] pid_project_name: The name of Pid Project.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if pid_organisation_id is None and not opts.urn:
                raise TypeError("Missing required property 'pid_organisation_id'")
            __props__['pid_organisation_id'] = pid_organisation_id
            __props__['pid_project_desc'] = pid_project_desc
            if pid_project_name is None and not opts.urn:
                raise TypeError("Missing required property 'pid_project_name'")
            __props__['pid_project_name'] = pid_project_name
        super(IndustrialPidProject, __self__).__init__(
            'alicloud:brain/industrialPidProject:IndustrialPidProject',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            pid_organisation_id: Optional[pulumi.Input[str]] = None,
            pid_project_desc: Optional[pulumi.Input[str]] = None,
            pid_project_name: Optional[pulumi.Input[str]] = None) -> 'IndustrialPidProject':
        """
        Get an existing IndustrialPidProject resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] pid_organisation_id: The ID of Pid Organisation.
        :param pulumi.Input[str] pid_project_desc: The description of Pid Project.
        :param pulumi.Input[str] pid_project_name: The name of Pid Project.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["pid_organisation_id"] = pid_organisation_id
        __props__["pid_project_desc"] = pid_project_desc
        __props__["pid_project_name"] = pid_project_name
        return IndustrialPidProject(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="pidOrganisationId")
    def pid_organisation_id(self) -> pulumi.Output[str]:
        """
        The ID of Pid Organisation.
        """
        return pulumi.get(self, "pid_organisation_id")

    @property
    @pulumi.getter(name="pidProjectDesc")
    def pid_project_desc(self) -> pulumi.Output[Optional[str]]:
        """
        The description of Pid Project.
        """
        return pulumi.get(self, "pid_project_desc")

    @property
    @pulumi.getter(name="pidProjectName")
    def pid_project_name(self) -> pulumi.Output[str]:
        """
        The name of Pid Project.
        """
        return pulumi.get(self, "pid_project_name")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

